using System;
using Telerik.OpenAccess;

namespace FirstStepsClasses
{
	/// <summary>
	/// The persistent Book class.
	/// </summary>
	[Persistent]
	public class Book : Product
	{
		//author is just a string here, to keep the datamodel simple
		private string author;
		
		//no-args constructor required by OpenAccess runtime system
		private Book() {}
		
		public Book(int productNo, string name, float unitPrice, string author) :
			base(productNo, name, unitPrice)
		{
			this.author = author;
		}

		public string Author
		{
			get { return author; }
			set { author = value; }
		}

		public override string ToString()
		{
			return author + ": " + base.ToString();
		}

	}
}
