using System;
using System.Collections.Generic;
using Telerik.OpenAccess;

namespace FirstStepsClasses
{
	/// <summary>
	/// The persistent Category class.
	/// Shows an index defined on a set member.
	/// </summary>
	[Persistent]
	public class Category
	{
		private string name;
		private string description;

		//This Generic IList collection of Product
		//references avoids casts in OQL-queries
		//this relationship is bidirectional
		private IList<Product> products;
		
		//OpenAccess enhancer requires a no-args constructor
		private Category() {}
		
		public Category(string name)
		{
			this.name = name;
		}

		public string Name
		{
			get { return name; }
			set { name = value; }
		}

		public string Description
		{
			get { return description; }
			set { description = value; }
		}

        public IList<Product> Products
		{
			get 
			{ 
				if( products == null )
				{
					products = new List<Product>();
				}
				return products; 
			}
		}

		public override string ToString()
		{
			return name;
		}

	}
}
