using System;
using Telerik.OpenAccess;

namespace FirstStepsClasses
{
	//it is not necessary or allowed to declare an enum as persistent
	//it is allowed, to use an enum from another library as persistent member,
	//e.g. System.IO.FileMode
	public enum FileSystem { ISO9660, Joliot, UDF };
	
	/// <summary>
	/// The persistent CdRom class.
	/// </summary>
	[Persistent]
	public class CdRom : Cd
	{
		private int? size;
		private FileSystem fileSystem;
		
		//no-args constructor required by Telerik.Telerik.Telerik.Telerik.OpenAccess runtime system
		private CdRom() {}

		public CdRom( int productNo, 
					  string name, 
					  float unitPrice, 
					  int size, 
					  FileSystem fileSystem) : 
			base(productNo, name, unitPrice)
		{
			this.size = size;
			this.fileSystem = fileSystem;
		}

        public int? Size
        {
            get { return size; }
            set { size = value; }
        }

		FileSystem FileSystem
		{
			get { return fileSystem; }
			set { fileSystem = value; }
		}

	}
}
