using System;
using System.Collections.Generic;
using Telerik.OpenAccess;

namespace FirstStepsClasses
{
	/// <summary>
	/// The persistent Company class.
	/// </summary>
	[Persistent]
	public class Company
	{
		private string name;
        private IList<Address> addresses;
		
		//Telerik.Telerik.Telerik.OpenAccess enhancer requires a no-args constructor
		protected Company() {}

		public Company(string name)
		{
			this.name = name;
		}

		public string Name
		{
			get { return name; }
			set { name = value; }
		}

        public IList<Address> Addresses
		{
			get 
			{
				if( addresses == null )
				{
                    addresses = new List<Address>();
				}
				return addresses;
			}
		}
		public override string ToString()
		{
			return name;
		}

	}
}
