using System;
using Telerik.OpenAccess;

namespace FirstStepsClasses
{
	/// <summary>
	/// The persistent Employee class.
	/// </summary>
	[Persistent]
	public class Employee
	{
		private string firstName;
		private string lastName;
		private Employee boss;
		private Address address;
		private DateTime birthDate;
        private PhoneNumber phoneNumber;
		
		//OpenAccess enhancer requires a no-args constructor
		private Employee() {}
		
		public Employee( string firstName,
						 string lastName,
						 Address address,
						 DateTime birthDate )
		{
			this.firstName = firstName;
			this.lastName = lastName;
			this.address = address;
			this.birthDate = birthDate;
            this.phoneNumber.Number = 1234;
            this.phoneNumber.AreaCode = 49;
		}

		public string FirstName
		{
			get { return firstName; }
			set { firstName = value; }
		}

		public string LastName
		{
			get { return lastName; }
			set { lastName = value; }
		}

		public Employee Boss
		{
			get { return boss; }
			set { boss = value; }
		}

		public Address Address
		{
			get { return address; }
			set { address = value; }
		}

		public DateTime BirthDate
		{
			get { return birthDate; }
			set { birthDate = value; }
		}

        public PhoneNumber PhoneNumber
        {
            get { return phoneNumber; }
            set { phoneNumber = value; }
        }

		public override string ToString()
		{
			return firstName + " " + lastName + "\t\t" + address + "\t\t" + phoneNumber ;
		}

	}
}
