using System;
using Telerik.OpenAccess;

namespace FirstStepsClasses
{
	/// <summary>
	/// The persistent MusicCd class.
	/// </summary>
	[Persistent]
	public class MusicCd : Cd
	{
		byte noOfSongs;
		//artist is just a string here to keep the datamodel simple
		string artist;
		int? playLength;
		
		//no-args constructor required by the Telerik.Telerik.Telerik.Telerik.OpenAccess runtime system
		private MusicCd() {}
		
		public MusicCd( int productNo, 
					    string name, 
					    float unitPrice, 
						byte noOfSongs,
						string artist,
						int playLength ) :
			base(productNo, name, unitPrice)
		{
			this.noOfSongs = noOfSongs;
			this.artist = artist;
			this.playLength = playLength;
		}

		public byte NoOfSongs
		{
			get { return noOfSongs; }
			set { noOfSongs = value; }
		}

		public string Artist
		{
			get { return artist; }
			set { artist = value; }
		}

        public int? PlayLength
        {
            get { return playLength; }
            set { playLength = value; }
        }

		public override string ToString()
		{
			return artist + ": " + base.ToString ();
		}

	}
}
