using System;
using Telerik.OpenAccess;

namespace FirstStepsClasses
{
	/// <summary>
	/// The persistent OrderDetail structs.
	/// OrderDetails are no independent objects but are aggregated
	/// by Order objects instead.
	/// </summary>
	[Persistent]
	public class OrderDetail 
	{
        [FetchField("Invoice Fetch Group")]
        private float unitPrice;
        [FetchField("Invoice Fetch Group")]
        private int quantity;
        [FetchField("Invoice Fetch Group")]
        private Product product;

		//a no-args constructor is required by the Telerik.OpenAccess runtime system
		private OrderDetail()
		{}

		public OrderDetail(float unitPrice, int quantity, Product product)
		{
			this.unitPrice = unitPrice;
			this.quantity = quantity;
			this.product = product;
		}

		public float UnitPrice
		{
			get { return unitPrice; }
			set { unitPrice = value; }
		}

		public int Quantity
		{
			get { return quantity; }
			set { quantity = value; }
		}

		public Product Product
		{
			get { return product; }
			set { product = value; }
		}

		public override string ToString()
		{
			return product + " | Quantity: " + quantity + " | Price: " + unitPrice;
		}

	}
}
