﻿using System;
using System.Collections.Generic;
using System.Text;
using Telerik.OpenAccess;
using System.ComponentModel;

namespace FirstStepsClasses
{
    [TypeDescriptionProvider(typeof(MyTypeDescriptionProvider))]
    [Telerik.OpenAccess.Persistent(IdentityField = "id")]
    public class Person
    {
        private int id;
        private string firstName;
        private string lastName;

        [FieldAlias("id")]
        public int Id
        {
            get { return id; }
            set { id = value; }
        }
        [FieldAlias("firstName")]
        public string FirstName
        {
            get { return firstName; }
            set { firstName = value; }
        }
        [FieldAlias("lastName")]
        public string LastName
        {
            get { return lastName; }
            set { lastName = value; }
        }
    }

    public class MyTypeDescriptionProvider : TypeDescriptionProvider
    {
        private IObjectScope scope;

        private TypeDescriptionProvider GetMetaData()
        {
            scope = Database.Get("DBConnFirstSteps").GetObjectScope();
            return scope.PersistentMetaData;
        }

        public override object CreateInstance(IServiceProvider provider, Type objectType, Type[] argTypes, object[] args)
        {
            return GetMetaData().CreateInstance(provider, objectType, argTypes, args);
        }
        public override ICustomTypeDescriptor GetTypeDescriptor(Type objectType, object instance)
        {
            return GetMetaData().GetTypeDescriptor(objectType, instance);
        }
    }
}
