using System;
using System.Collections;
using Telerik.OpenAccess;

namespace FirstStepsClasses
{
	/// <summary>
	/// The persistent Product class. 
	/// The class definition is changed compared to the previous
	/// exercise.
	/// </summary>
	[Persistent]
	public class Product
	{
		private int productNo;
        [FetchField("Invoice Fetch Group")]
        private string name;
		private float unitPrice;
		private Supplier supplier;
		//this relationship is bidirectional
		private Category category;
		
		//no-args constructor required by the Telerik.OpenAccess enhancer
		public Product() {}

        public Product(int productNo, 
			string name, 
			float unitPrice ) :
			this(productNo, name, unitPrice, null)
		{}

        public Product(int productNo, 
						   string name, 
						   float unitPrice,
						   Supplier supplier )
		{
			this.productNo = productNo;
			this.name = name;
			this.unitPrice = unitPrice;
			this.supplier = supplier;
		}

		public int ProductNo
		{
			get { return productNo; }
			set { productNo = value; }
		}

		public string Name
		{
			get { return name; }
			set { name = value; }
		}

		public float UnitPrice
		{
			get { return unitPrice; }
			set { unitPrice = value; }
		}

		public Supplier Supplier
		{
			get { return supplier; }
			set { supplier = value; }
		}

		public Category Category
		{
			get { return category; }
			set 
			{ 
				if( category != null && category != value )
				{
					category.Products.Remove(this);
				}
				category = value;
				if( category != null )
				{
					category.Products.Add(this);
				}
			}
		}

		public override string ToString()
		{
			return name + " (" + productNo + ")";
		}
	}
}
