using System;
using Telerik.OpenAccess;

namespace FirstStepsClasses
{
	/// <summary>
	/// The persistent Supplier class.
	/// </summary>
	[Persistent]
	public class Supplier : Company
	{
		private int supplierNo;
		private string homePage;

		//no-args constructor required by the OpenAccess enhancer
		private Supplier() {}
		
		public Supplier(string name, int supplierNo)
			: base(name)
		{
			this.supplierNo = supplierNo;
		}

		public Supplier( string name, int supplierNo, string homePage)
			: base(name)
		{
			this.supplierNo = supplierNo;
			this.homePage = homePage;
		}

		public int SupplierNo
		{
			get { return supplierNo; }
		}

		public string HomePage
		{
			get { return homePage; }
			set { homePage = value; }
		}
	}
}
