﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;
using Telerik.OpenAccess.MetaData;
using FirstStepsClasses;
using Telerik.OpenAccess;

public partial class AddNewPerson : System.Web.UI.UserControl
{
    IObjectScope scope;
    FirstStepsClasses.Person addedPerson;
    protected void Page_Load(object sender, EventArgs e)
    {
        scope = Database.Get("DBConnFirstSteps").GetObjectScope();
        CheckBoxFirstName.Checked = CheckAritficial("firstName");
        CheckBoxLastName.Checked = CheckAritficial("lastName");
        CheckBoxAge.Checked = CheckAritficial("age");
        CheckBoxAddress.Checked = CheckAritficial("address");
    }
    protected void Button1_Click(object sender, EventArgs e)
    {
        IPersistentTypeDescriptor ptd = scope.PersistentMetaData.GetPersistentTypeDescriptor(typeof(Person));
        PropertyDescriptorCollection pdc = ptd.GetProperties();

        addedPerson = new FirstStepsClasses.Person();
        scope.Transaction.Begin();
        scope.Add(addedPerson);

        string firstName = RadTextBoxFirstName.Text;
        string lastName = RadTextBoxLastName.Text;
        int age;
        int.TryParse(RadTextBoxAge.Text, out age);
        string address = RadTextBoxAddress.Text;

        SetFieldValueUsingGenericAccess(pdc, "firstName", firstName);
        SetFieldValueUsingGenericAccess(pdc, "lastName", lastName);
        SetFieldValueUsingGenericAccess(pdc, "age", age);
        SetFieldValueUsingGenericAccess(pdc, "address", address);

        scope.Transaction.Commit();

    }
    private bool CheckAritficial(string field)
    {
        IPersistentTypeDescriptor ptd = scope.PersistentMetaData.GetPersistentTypeDescriptor(typeof(Person));
        PropertyDescriptorCollection pdc = ptd.GetProperties();
        return ptd.IsArtificialField(pdc[field]);
    }
    private void SetFieldValueUsingGenericAccess(PropertyDescriptorCollection pdc, string fieldName, object value)
    {
        PropertyDescriptor pd = pdc[fieldName];
        pd.SetValue(addedPerson, value);
    }
}
